import bufToImageUrl from "./BuffToImg";

export default (f: File): Promise<Image> => new Promise(async (res, rej) => {

  const arr = await f.arrayBuffer()

  const img = document.createElement("img");
  img.src = bufToImageUrl(arr, f.type);

  img.onload = async () => {
    res({
      id: 0,
      width: img.width,
      height: img.height,
      name: f.name,
      filename: f.name,
      type: f.type,
      colors: [],
      overlayData: new ArrayBuffer(0),
      lastModified: f.lastModified,
      data: arr
    });
  };

});