import '@tensorflow/tfjs-backend-webgl';
import "@tensorflow/tfjs-backend-cpu"
import { loadGraphModel } from '@tensorflow/tfjs-converter';
import { getURL, SemanticSegmentation } from '@tensorflow-models/deeplab';

const base = 'ade20k';        // set to your preferred model, out of `pascal`,`cityscapes` and `ade20k`
const createModel = async () => {
  const quantizationBytes = 2;  // either 1, 2 or 4
  const modelUrl = getURL(base, quantizationBytes);
  const rawModel = await loadGraphModel(modelUrl);
  return new SemanticSegmentation(rawModel, base);
};

const model = createModel();
model.then(() => console.log(`Loaded the model successfully!`));

self.addEventListener('message', async (e) => {

  const { pixels, width, height, i } = e.data;

  var array = new Uint8ClampedArray(pixels);

  var image = new ImageData(array, width, height);

  const result = await (await model).segment(image);

  //@ts-ignore
  self.postMessage({ i, result })

});